//+------------------------------------------------------------------+
//|                                       TBST TRADING ZONE.mq4      |
//|                                  Copyright  2012, YONOJAYA      |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, YONOJAYA"
#property indicator_chart_window

extern int NumberOfDays = 10;

extern string Zon_Start = "0:00";
extern string Zon_End = "03:00";

extern color Color1 = DimGray;
extern color Color2 = C'40,40,40';
extern bool ShowBestTradingZones = true;
extern int Line_Style = 4;
extern int Line_Width = 0;

int i,varCurrentTime,varZonStart,varZonEnd,varShiftStart,varShiftEnd,varRecStart,varRecEnd;
double varHighest,varLowest;

int init() {
   DeleteObjects();
   for (i = 0; i < NumberOfDays; i++) {  
      ObjectCreate("ZON_HIGH"+ i, OBJ_TREND, 0, 0, 0, 0, 0);
      ObjectSet("ZON_HIGH"+ i, OBJPROP_STYLE, Line_Style);
      ObjectSet("ZON_HIGH"+ i, OBJPROP_WIDTH, Line_Width);
      ObjectSet("ZON_HIGH"+ i, OBJPROP_COLOR, Color1);
      ObjectSet("ZON_HIGH"+ i, OBJPROP_BACK, TRUE); 
      
      ObjectCreate("ZON_LOW" + i, OBJ_TREND, 0, 0, 0, 0, 0);
      ObjectSet("ZON_LOW" + i, OBJPROP_STYLE, Line_Style);
      ObjectSet("ZON_LOW" + i, OBJPROP_WIDTH, Line_Width);
      ObjectSet("ZON_LOW" + i, OBJPROP_COLOR, Color1);
      ObjectSet("ZON_LOW" + i, OBJPROP_BACK, TRUE);      
      
      ObjectCreate("ZON_REC" + i, OBJ_RECTANGLE, 0, 0, 0);
      ObjectSet("ZON_REC" + i, OBJPROP_COLOR, Color2);
      ObjectSet("ZON_REC" + i, OBJPROP_WIDTH, 2);     
      ObjectSet("ZON_REC" + i, OBJPROP_BACK, TRUE);  
   }
   return (0);
}

int deinit() {
   DeleteObjects();  
   ObjectDelete("EURO");  
   ObjectDelete("CANDLE");
   return (0);
}

int start() {
   int l_ind_counted_0 = IndicatorCounted();
   varCurrentTime = TimeCurrent();
   for (i = 0; i < NumberOfDays; i++) {        
         DrawObjectsHigh(varCurrentTime, "ZON_HIGH" + i, Zon_Start, Zon_End);
         DrawObjectsLow(varCurrentTime, "ZON_LOW" + i, Zon_Start, Zon_End);        
      if (ShowBestTradingZones) {         
         DrawObjectsRec(varCurrentTime, "ZON_REC" + i, Zon_Start, Zon_End);                  
      }
      for (varCurrentTime = decDateTradeDay(varCurrentTime); TimeDayOfWeek(varCurrentTime) > 5; varCurrentTime = decDateTradeDay(varCurrentTime)) {
      }
   } 
   return (0);
}

void DeleteObjects() {
   for (i = 0; i < NumberOfDays; i++) {     
      ObjectDelete("ZON_HIGH" + i);      
      ObjectDelete("ZON_LOW" + i);         
      ObjectDelete("ZON_REC" + i);       
   }
}

void DrawObjectsHigh(int varCurTime, string varName, string as_12, string as_20) {
   varZonStart = StrToTime(TimeToStr(varCurTime, TIME_DATE) + " " + as_12);
   varZonEnd = StrToTime(TimeToStr(varCurTime, TIME_DATE) + " " + as_20);
   varShiftStart = iBarShift(NULL, 0, varZonStart - 60 * Period());
   varShiftEnd = iBarShift(NULL, 0, varZonEnd);
   varHighest = High[iHighest(NULL, 0, MODE_HIGH, varShiftStart - varShiftEnd, varShiftEnd)];
   ObjectSet(varName, OBJPROP_TIME1, varZonStart);
   ObjectSet(varName, OBJPROP_PRICE1, varHighest);   
   ObjectSet(varName, OBJPROP_TIME2, varZonEnd);
   ObjectSet(varName, OBJPROP_PRICE2, varHighest);
   ObjectSet(varName, OBJPROP_RAY, false);
}

void DrawObjectsLow(int varCurTime, string varName, string as_12, string as_20) {
   varZonStart = StrToTime(TimeToStr(varCurTime, TIME_DATE) + " " + as_12);
   varZonEnd = StrToTime(TimeToStr(varCurTime, TIME_DATE) + " " + as_20);
   varShiftStart = iBarShift(NULL, 0, varZonStart - 60 * Period());
   varShiftEnd = iBarShift(NULL, 0, varZonEnd);
   varLowest = Low[iLowest(NULL, 0, MODE_LOW, varShiftStart - varShiftEnd, varShiftEnd)];
   ObjectSet(varName, OBJPROP_TIME1, varZonStart);
   ObjectSet(varName, OBJPROP_PRICE1, varLowest);
   ObjectSet(varName, OBJPROP_TIME2, varZonEnd);
   ObjectSet(varName, OBJPROP_PRICE2, varLowest);
   ObjectSet(varName, OBJPROP_RAY, false);
}



void DrawObjectsRec(int varCurTime, string varName, string as_12, string as_20) {
   varRecStart = StrToTime(TimeToStr(varCurTime, TIME_DATE) + " " + as_12);
   varRecEnd = StrToTime(TimeToStr(varCurTime, TIME_DATE) + " " + as_20);
   varShiftStart = iBarShift(NULL, 0, varRecStart - 60 * Period());
   varShiftEnd = iBarShift(NULL, 0, varRecEnd);
   varHighest = High[iHighest(NULL, 0, MODE_HIGH, varShiftStart - varShiftEnd, varShiftEnd)] - 0.75 * Point;
   varLowest = Low[iLowest(NULL, 0, MODE_LOW, varShiftStart - varShiftEnd, varShiftEnd)] + Point / 2.0;
   ObjectSet(varName, OBJPROP_TIME1, varRecStart);
   ObjectSet(varName, OBJPROP_PRICE1, varHighest);
   ObjectSet(varName, OBJPROP_TIME2, varRecEnd);
   ObjectSet(varName, OBJPROP_PRICE2, varLowest);
}


int decDateTradeDay(int varCurTime) {
   int li_4 = TimeYear(varCurTime);
   int li_8 = TimeMonth(varCurTime);
   int li_12 = TimeDay(varCurTime);
   int l_hour_16 = TimeHour(varCurTime);
   int l_minute_20 = TimeMinute(varCurTime);
   li_12--;
   if (li_12 == 0) {
      li_8--;
      if (li_8 == 0) {
         li_4--;
         li_8 = 12;
      }
      if (li_8 == 1 || li_8 == 3 || li_8 == 5 || li_8 == 7 || li_8 == 8 || li_8 == 10 || li_8 == 12) li_12 = 31;
      if (li_8 == 2) {
         if (MathMod(li_4, 4) == 0.0) li_12 = 29;
         else li_12 = 28;
      }
      if (li_8 == 4 || li_8 == 6 || li_8 == 9 || li_8 == 11) li_12 = 30;
   }
   return (StrToTime(li_4 + "." + li_8 + "." + li_12 + " " + l_hour_16 + ":" + l_minute_20));
}


